﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace FirstApplication
{
    public partial class Form1 : Form
    {
        SerialPort RS232; //deklaracja portu szeregowego
        byte[] mData = new byte[1]; //dane wysylane na port szeregowy (tablica, bo port szeregowy przyjmuje dane w tej formie)
        public Form1()
        {

            InitializeComponent(); //inicjalizacja komponentow okienka (przyciskow, tekstow okna itp.)
            RS232 = new SerialPort("COM5", 9600, Parity.None, 8, StopBits.One); //tworzenie nowego obiektu typu SerialPort
            RS232.ReadTimeout = 100; //funkcja odczytu z portu jest blokująca, tzn. jeśli nie uda się odczytać nic z portu
            //to program będzie oczekiwał aż w końcu cos przyjdzie na port (zwiesi się)
            //dlatego ustalamy czas timeoutu, przy którym jeśli w ciągu określonego czasu nie uda się odczytać danych z portu,
            //to program będzie kontynuował działanie
            try
            {
                RS232.Open(); //proba otwarcie portu
            }
            catch (Exception e) //jesli sie nie powiodla (bo np. zajety)
            {
                MessageBox.Show("Tak być nie bedzie: " + e.ToString(), "Błąd przy otwieraniu portu", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }
            ChipButton.Text = "CHIP"; //ustawienie tekstu przycisku
            
        }

        private void ChipButton_Click(object sender, EventArgs e)
        {
            ChipButton.Text += " CHIP"; //powiekszanie napisu na przycisku
        }

        private void SendButton_Click(object sender, EventArgs e)
        {
            try //proba wyslania na port
            {
                RS232.Write(mData, 0, 1);
                mData[0]++; //inkrementacja zmiennej
                SendButton.Text = "Wyślij na port: " + mData[0].ToString(); //ustawienie nowego tekstu na przycisku wysylania (zeby bylo wiadomo co bedzie wyslane w dalszej kolejnosci)
            }
            catch (Exception ex) //jesli sie nie powiedzie
            {
                MessageBox.Show("Tak być nie bedzie: " + ex.ToString(), "Błąd przy wysyłaniu na port", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }
        }

        private void ReadButton_Click(object sender, EventArgs e)
        {
            try
            {
                ReceivedDataTextBox.Text += RS232.ReadByte() + " ";
            }
            catch (TimeoutException)
            {
                //ignorujemy, bo to tylko timeout
            }
            catch (Exception exc)
            {
                MessageBox.Show("Tak być nie bedzie: " + exc.ToString(), "Błąd przy odczycie z portu", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }
            
        }
    }
}
